import { Savable } from "./Savable";
import { Deletable } from "./Deletable";
import { Loadable } from "./Loadable";
import { ObjectPath } from "./ObjectPath";
import { LoginData } from "./LoginData";
export declare class FirebaseObject<T extends object = {}> implements Savable<T>, Deletable<T>, Loadable<T> {
    static tableName: string;
    loginDataInstance: () => LoginData;
    data: T;
    tablePath: ObjectPath;
    static classTablePath: ObjectPath;
    keys: {
        key: string;
        [otherProperty: string]: any;
    }[];
    importData: (data: T) => void;
    loadSelf: (callback: any) => void;
    save: () => Promise<any>;
    willSave: () => void;
    shouldSave: () => boolean;
    didSave: () => void;
    delete: () => void;
    willDelete: () => void;
    shouldDelete: () => boolean;
    didDelete: () => void;
    loadChildren: (callback: any) => void;
    loadAllChildren: (callback: any) => void;
    childTypes: any[];
    children: {};
    associatedObjectTypes: any[];
    associatedObjects: {};
    loadAssociatedObjects: (callback: any) => void;
    loadAssociatedObjectType: (type: any, callback: any) => void;
    loadAssociatedObject: (type: any, id: any, callback: any) => void;
}
